﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.IO;

namespace getXmlSample2
{
    class Program
    {
        static void Main(string[] args)
        {
            using (ServiceHost host=new ServiceHost(typeof(MyService)))
            {
                host.Open();
                Console.WriteLine("服务已打开。");
                Console.Read();
            }
        }
    }

    [ServiceContract]
    public interface IData
    {
        [OperationContract]
        [WebGet(UriTemplate = "getdata?f={format}")]
        string GetData(string format);
    }

    public class MyService : IData
    {
        public string GetData(string format)
        {
            string res = null;
            Student stu = new Student
            {
                StuID = 3, StuName = "小白"
            };
            using (MemoryStream ms=new MemoryStream())
            {
                XmlObjectSerializer sz = null;
                if (format != null && format.ToLower() == "xml")
                {
                    sz = new DataContractSerializer(stu.GetType());
                }
                else
                {
                    sz = new DataContractJsonSerializer(stu.GetType());

                }
                sz.WriteObject(ms, stu);
                res = Encoding.UTF8.GetString( ms.ToArray());
            }
            return res;
        }
    }

    [DataContract(Namespace = "http://sample",Name = "student")]
    public sealed class Student
    {
        [DataMember(Name = "stu_id")]
        public int StuID { get; set; }

        [DataMember(Name = "stu_name")]
        public string StuName { get; set; }
    }
}
